<template lang="pug">
div
  v-layout(row wrap)
    v-flex(xs12 sm12 md12)
      p.b-content__title-section Выберите регион:

  v-layout(row wrap justify-space-between)
    v-flex(xs12 sm12 md12 d-flex)
        v-select(
          v-model="region"
          label="Регион"
          :items="getRegions"
          item-value="id"
          item-text="name"
          :error-messages="regionErrors"
          outline
        )
  v-layout(row wrap)
    v-flex(xs12 sm12 md12)
      p.b-content__title-section Выберите диапазон дат:

  v-layout(row wrap justify-space-between)
    v-flex(xs12 sm6 md6 d-flex)
      date-picker(
        v-model="startDate"
        label="Дата начала"
        :defaultValue="defaultStartDate"
        :errorMessage="startDateErrors"
      )

    v-flex(xs12 sm6 md6 d-flex)
      date-picker(
        v-model="finishDate"
        label="Дата конца"
        :defaultValue="defaultFinishDate"
        :errorMessage="finishDateErrors"
      )

  v-layout(row wrap)
    v-flex(xs12 sm12 md12)
      p.b-content__title-section Выберите диапазон времени:

  v-layout(row wrap justify-space-between)
    v-flex(xs12 sm6 md6 d-flex)
      date-picker(
        v-model="startTime"
        type="time"
        label="Начальное вермя"
        format="HH:mm:ss"
        :defaultValue="defaultStartTime"
        :errorMessage="startTimeErrors"
      )

    v-flex(xs12 sm6 md6 d-flex)
      date-picker(
        v-model="finishTime"
        type="time"
        label="Конечное время"
        format="HH:mm:ss"
        :defaultValue="defaultFinishTime"
        :errorMessage="finishTimeErrors"
      )
  
  files-list(
    hasTopSpace="true"
    :loadAction="runLoadReports"
    :files="getFiles"
    :fileServer="getFileServer"
  )
</template>

<script>
import { mapGetters } from 'vuex';
import moment from 'moment';
import { required, email } from 'vuelidate/lib/validators';
import DatePicker from '../components/datepicker/index.vue';
import FilesList from '../components/files-list/index.vue';

export default {
  name: 'MedicsSmall',
  components: {
    DatePicker,
    FilesList
  },
  computed: {
    ...mapGetters([
      'getFileServer',
      'getRegions',
    ]),
    ...mapGetters('medicsSmall', ['getFiles']),
    startDate: {
      get() {
        return this.$store.getters['medicsSmall/getStartDate'];
      },
      set(value) {
        this.$store.commit('medicsSmall/setStartDate', value);
      },
    },
    finishDate: {
      get() {
        return this.$store.getters['medicsSmall/getFinishDate'];
      },
      set(value) {
        this.$store.commit('medicsSmall/setFinishDate', value);
      },
    },
    startDateErrors() {
      const errors = [];
      if (!this.$v.startDate.$dirty) return errors;
      if (!this.$v.startDate.isDate) {
        errors.push('Обязательно для заполнения.');
      }
      if (!this.$v.startDate.isAfterDate) {
        errors.push('Дата начала должна быть позже даты конца.');
      }
      return errors;
    },
    finishDateErrors() {
      const errors = [];
      if (!this.$v.finishDate.$dirty) return errors;
      if (!this.$v.finishDate.isDate) {
        errors.push('Обязательно для заполнения.');
      }
      if (!this.$v.finishDate.isBeforeDate) {
        errors.push('Дата конца должна быть позже даты начала.');
      }
      return errors;
    },
    defaultStartDate() {
      return moment(this.$store.getters['medicsSmall/getStartDate'], 'DD.MM.YYYY').isValid()
        ? moment(this.$store.getters['medicsSmall/getStartDate'], 'DD.MM.YYYY')
        : moment().subtract(1, 'days');
    },
    defaultFinishDate() {
      return moment(this.$store.getters['medicsSmall/getFinishDate'], 'DD.MM.YYYY').isValid()
        ? moment(this.$store.getters['medicsSmall/getFinishDate'], 'DD.MM.YYYY')
        : moment();
    },

    startTime: {
      get() {return this.$store.getters['medicsSmall/getStartTime']},
      set(value) {
        this.$store.commit('medicsSmall/setStartTime', value);
      },
    },
    finishTime: {
      get() {return this.$store.getters['medicsSmall/getFinishTime']},
      set(value) {
        this.$store.commit('medicsSmall/setFinishTime', value);
      },
    },
    defaultStartTime() {
      return moment(this.$store.getters['medicsSmall/getStartTime'], 'HH:mm').isValid()
        ? moment(this.$store.getters['medicsSmall/getStartTime'], 'HH:mm')
        : moment('08:00:00', 'HH:mm');
    },
    defaultFinishTime() {
      return moment(this.$store.getters['medicsSmall/getFinishTime'], 'HH:mm').isValid()
        ? moment(this.$store.getters['medicsSmall/getFinishTime'], 'HH:mm')
        : moment('20:00:00', 'HH:mm');
    },
    startTimeErrors() {
      const errors = [];
      if (!this.$v.startTime.$dirty) return errors;
      if (!this.$v.startTime.isTime) {
        errors.push('Обязательно для заполнения.');
      }
      if (!this.$v.startTime.isAfterTime) {
        errors.push('Начальное время должно быть раньше конечного времени.');
      }
      return errors;
    },
    finishTimeErrors() {
      const errors = [];
      if (!this.$v.finishTime.$dirty) return errors;
      if (!this.$v.finishTime.isTime) {
        errors.push('Обязательно для заполнения.');
      }
      if (!this.$v.finishTime.isBeforeTime) {
        errors.push('Конечное время должно быть позже начального времени.');
      }
      return errors;
    },
    region: {
      get() {return this.$store.getters['medicsSmall/getRegion']},
      set(value) {
        this.$store.commit('medicsSmall/setRegion', value);
      }
    },
    regionErrors() {
      const errors = [];
      if (!this.$v.region.$dirty) return errors;
      if (!this.$v.region.required) {
        errors.push('Обязательно для заполнения.');
      }
      return errors;
    }
  },
  validations: {
    startDate: {
      isDate: value =>  moment(value, 'DD.MM.YYYY').isValid(),
      isAfterDate(value) {
        return moment(value, 'DD.MM.YYYY')
          .isSameOrBefore(moment(this.finishDate, 'DD.MM.YYYY'));
      },
    },
    finishDate: {
      isDate: value =>  moment(value, 'DD.MM.YYYY').isValid(),
      isBeforeDate(value) {
        return moment(value, 'DD.MM.YYYY')
          .isSameOrAfter(moment(this.startDate, 'DD.MM.YYYY'));
      },
    },
    startTime: {
      isTime: value => moment(value, 'HH:mm:ss').isValid(),
      isAfterTime(value) {
        return moment(value, 'HH:mm:ss')
          .isSameOrBefore(moment(this.finishTime, 'HH:mm:ss'));
      },
    },
    finishTime: {
      isTime: value => moment(value, 'HH:mm:ss').isValid(),
      isBeforeTime(value) {
        return moment(value, 'HH:mm:ss')
          .isSameOrAfter(moment(this.startTime, 'HH:mm:ss'));
      },
    },
    region: { required },
  },
  watch: {
    startDate() {
      this.$store.dispatch('resetTimeId');
    },
    finishDate() {
      this.$store.dispatch('resetTimeId');
    },
    startTime() {
      this.$store.dispatch('resetTimeId');
    },
    finishTime() {
      this.$store.dispatch('resetTimeId');
    },
    region() {
      this.$store.dispatch('resetTimeId');
    },
  },
  methods: {
    runLoadReports() {
      this.$v.$touch();

      if (!this.$v.$invalid) {
        this.$store.dispatch('addReport');
      }
    },
  },
};
</script>
